From 0cd342913ac460a36db921590bd9a3c93a5f43d9 Mon Sep 17 00:00:00 2001
From: David Tolnay <dtolnay@gmail.com>
Date: Sep 24 2020 13:40:27 +0000
Subject: [PATCH 909/2232] Make buck/bazel generated filepaths match source path with extension


---

diff --git a/demo/BUCK b/demo/BUCK
index eebe5c2..0640a53 100644
--- a/demo/BUCK
+++ b/demo/BUCK
@@ -22,7 +22,7 @@ cxx_library(
 genrule(
     name = "gen-header",
     srcs = ["src/main.rs"],
-    out = "generated.h",
+    out = "src/main.rs.h",
     cmd = "$(exe //:codegen) --header ${SRCS} > ${OUT}",
     type = "cxxbridge",
 )
@@ -30,16 +30,14 @@ genrule(
 genrule(
     name = "gen-source",
     srcs = ["src/main.rs"],
-    out = "generated.cc",
+    out = "src/main.rs.cc",
     cmd = "$(exe //:codegen) ${SRCS} > ${OUT}",
     type = "cxxbridge",
 )
 
 cxx_library(
     name = "include",
-    exported_headers = {
-        "src/main.rs.h": ":gen-header",
-    },
+    exported_headers = [":gen-header"],
 )
 
 cxx_library(
diff --git a/demo/BUILD b/demo/BUILD
index 9a46fa2..c1fb429 100644
--- a/demo/BUILD
+++ b/demo/BUILD
@@ -23,7 +23,7 @@ cc_library(
 genrule(
     name = "gen-header",
     srcs = ["src/main.rs"],
-    outs = ["main.rs.h"],
+    outs = ["src/main.rs.h"],
     cmd = "$(location //:codegen) --header $< > $@",
     tools = ["//:codegen"],
 )
@@ -31,7 +31,7 @@ genrule(
 genrule(
     name = "gen-source",
     srcs = ["src/main.rs"],
-    outs = ["generated.cc"],
+    outs = ["src/main.rs.cc"],
     cmd = "$(location //:codegen) $< > $@",
     tools = ["//:codegen"],
 )
@@ -39,7 +39,6 @@ genrule(
 cc_library(
     name = "include",
     hdrs = [":gen-header"],
-    include_prefix = "demo/src",
 )
 
 cc_library(
diff --git a/tests/BUCK b/tests/BUCK
index 79ae790..4a14f2a 100644
--- a/tests/BUCK
+++ b/tests/BUCK
@@ -37,20 +37,20 @@ cxx_library(
 genrule(
     name = "gen-lib-header",
     srcs = ["ffi/lib.rs"],
-    out = "lib.rs.h",
+    out = "ffi/lib.rs.h",
     cmd = "$(exe //:codegen) --header ${SRCS} > ${OUT}",
 )
 
 genrule(
     name = "gen-lib-source",
     srcs = ["ffi/lib.rs"],
-    out = "lib.rs.cc",
+    out = "ffi/lib.rs.cc",
     cmd = "$(exe //:codegen) ${SRCS} > ${OUT}",
 )
 
 genrule(
     name = "gen-module-source",
     srcs = ["ffi/module.rs"],
-    out = "module.rs.cc",
+    out = "ffi/module.rs.cc",
     cmd = "$(exe //:codegen) ${SRCS} > ${OUT}",
 )
diff --git a/tests/BUILD b/tests/BUILD
index ba763e0..c690994 100644
--- a/tests/BUILD
+++ b/tests/BUILD
@@ -39,7 +39,7 @@ cc_library(
 genrule(
     name = "gen-lib-header",
     srcs = ["ffi/lib.rs"],
-    outs = ["lib.rs.h"],
+    outs = ["ffi/lib.rs.h"],
     cmd = "$(location //:codegen) --header $< > $@",
     tools = ["//:codegen"],
 )
@@ -47,7 +47,7 @@ genrule(
 genrule(
     name = "gen-lib-source",
     srcs = ["ffi/lib.rs"],
-    outs = ["lib.rs.cc"],
+    outs = ["ffi/lib.rs.cc"],
     cmd = "$(location //:codegen) $< > $@",
     tools = ["//:codegen"],
 )
@@ -56,12 +56,13 @@ cc_library(
     name = "lib-include",
     hdrs = [":gen-lib-header"],
     include_prefix = "cxx-test-suite",
+    strip_include_prefix = "ffi",
 )
 
 genrule(
     name = "gen-module-source",
     srcs = ["ffi/module.rs"],
-    outs = ["module.rs.cc"],
+    outs = ["ffi/module.rs.cc"],
     cmd = "$(location //:codegen) $< > $@",
     tools = ["//:codegen"],
 )

